<script>
  import {scaleLinear} from 'd3-scale';
  import {scaleOrdinal} from "d3-scale";
  import {schemeDark2} from "d3-scale-chromatic";
  import {extent} from "d3-array";

  // Dimensions
  const width = 800;
  const height = 100;
  const margin = { top: 20, right: 5, bottom: 5, left: 5 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const values = [
    { x: 2, y: 1, category: "cat1" },
    { x: 4, y: 2, category: "cat3" },
    { x: 6, y: 1, category: "cat2" },
    { x: 7, y: 3, category: "cat3" },
    { x: 9, y: 1, category: "cat2" }
  ];

  let x_scaler = scaleLinear().domain([0, 10]).range([0, innerWidth]);
  let y_scaler = scaleLinear().domain([3, 0]).range([0, innerHeight]);
  let ordinal_scaler = scaleOrdinal().domain(["cat1", "cat3"]).range(schemeDark2);
</script>

<svg viewBox="0 0 {width} {height}">
  <g transform="translate({margin.left},{margin.top})">
    <!--  -->
    <line x1="{margin.left}" y1="{innerHeight}" x2="{innerWidth}" y2="{innerHeight}" stroke="black" />
    {#each values as value}
      <circle cx={x_scaler(value.x)} cy={y_scaler(value.y)} r=5 fill="{ordinal_scaler(value.category)}" />
      <line x1="{x_scaler(value.x)}" y1="{innerHeight}" x2="{x_scaler(value.x)}" y2="{y_scaler(value.y) + 5}" stroke="black" />
      <text class="valueLabel" x={x_scaler(value.x)} y={y_scaler(value.y)-10}>{value.y}</text>
    {/each}
  </g>
</svg>

<style>
  text {
    text-anchor: middle;
    font-size: small;
  }
</style>
